/*
Brute-force hash cracker.  Checks SHA-1 hash of various strings until
it hits the one it's shooting for.

Orion Sky Lawlor, olawlor@acm.org, 2006/02/27 (public domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sha1.h"
#include "sha1.cpp"

/* Hash code of the password we're searching for */
SHA1_hash_t target;

/* If 1, print out test strings as they're checked */
int verbose=1;

/* Check if this C string has the same hash as the target */
void check(const char *str) {
	SHA1_hash_t h=SHA1_hash(str);
	if (verbose)
		printf("Checking against %d-byte string '%s' -> %s\n",
			strlen(str),str,SHA1_hex_from_hash(h).c_str());
	if (h==target) {
		printf("Target hash matches '%s'!\n",str);
		exit(0);
	}
}

int main(int argc,char *argv[]) {
	const char *targetString=argv[1];
	if (targetString==NULL) {
		printf("Usage: brute <target SHA-1 hash>\n"); 
		exit(1);
	}
	target=SHA1_hash_from_hex(targetString);
	printf("Searching target space...\n");
	char str[32]; memset(str,0,32);
	
	printf("Checking all single-digit passwords\n");
	for (str[0]=' ';str[0]!='~';str[0]++) check(str);
	
	printf("Couldn't find matching hash...\n");
	return 0;
}
